<?php namespace EscapeWork\Manager\Calendars\Models;

use EscapeWork\Manager\Calendars\Repositories\CalendarDayRepository;
use EscapeWork\Manager\Calendars\Extensions\CalendarDayCollection;
use Eloquent;

class CalendarDay extends Eloquent implements CalendarDayRepository
{

   /**
    * table
    */
    protected $table = 'calendar_days';

    protected $fillable = array(
        'calendar_id',
        'day'
    );

    public static $validationRules = array(
        'day' => array('required')
    );

    /**
    * Mensagens de validação
    */
    public static $validationMessages = array(
        'day.required'           => 'O dia do evento é obrigatório',
    );

    /**
    * Inserindo várias datas a partir de um array
    */
    public function insertFromArray($dates)
    {
        foreach ((array) $dates as $date) {
            $calendarDay = new CalendarDay();
            $calendarDay->calendar_id = $this->calendar_id;
            $calendarDay->day = to_timestamp($date, 'd/m/Y', 'Y-m-d');

            if ($calendarDay->validate()) {
                $calendarDay->save();
            }
        }
    }

    /**
    * Deletando todas as datas de uma edição
    */
    public function deleteAllFromEdition($calendar_id = null)
    {
        if (! is_null($calendar_id)) {
            $this->calendar_id = $calendar_id;
        }

        return $this->where('calendar_id', '=', $this->calendar_id)->delete();
    }

    /**
     * New Collection
     */
    public function newCollection(array $models = array())
    {
        return new CalendarDayCollection($models);
    }
}